--- Mise à jour de la table de configuration
\r posh
-- Correction bug_356 : ajout de la possibilité de désactiver le réseau social
DROP PROCEDURE IF EXISTS SetEditable;
delimiter |
CREATE PROCEDURE SetEditable(_name VARCHAR( 32 ), _editable tinyint(1))
begin
    -- Au sein d'une procédure on se doit de gérer les encodages correctement
    set @_name = _name collate utf8_unicode_ci;
    UPDATE `adm_config` SET `editable`=_editable WHERE `parameter`=@_name;
end|
delimiter ;
CALL SetEditable('useSharing', 1);
CALL SetEditable('homeDivs', 1);
CALL SetEditable('useGroup', 1);
DROP PROCEDURE SetEditable;
