<?php
/****************************************************
*	Widget externe function               		    *
*	file: externe_lib.php	                        *
*	version: 2.20								    *
*	date: 29/10/2008							    *
*	author: David PERRIN (équipe Eole, CETIAD Dijon)*
*	email: David.Perrin@ac-dijon.fr                 *
****************************************************/
function getUrl($row,$id) {
    if ($row["type"]=="url")
    {
	    $url=$row["modcontent"];
    	if ($url=="")
	    {
    		exit();
	    }
    	$url.=(strpos($url,"?")===false)?"?":"&";
    }
    else
    {
	    $url="../modules/module".$id.".php?";
    }
    return $url;
}

function verifSite ($url) {
    /* Controle si c'est un site de confiance */
    global $DB;
    $DB->getResults("SELECT site FROM externe_widget");
    $row=$DB->fetch(0);
    $site=$row['site'];
    $tab=split(";",$site);
    $tab2=split("\.",$url);
    $url=$tab2[1];
    if(in_array($url, $tab)) {
        return true;
    }
    else {
        return false;
    }
}


function verifWidget ($url) {
    /* Le widget est-il déjà dans la base ? renvoie l'id si oui */
    global $DB;
    $DB->getResults("SELECT id,url FROM dir_item");
    while ($row=$DB->fetch(0)){
        if($url==$row['url']){
            return $row['id'];
        }
    }
    return false;
}


function GetFormat($row) {
    /* Renvoie le format du widget Url ou Interne
     * Normalement c'est une url
     * */
    if ($row["type"]=="url")
    {
    	$url=$row["modcontent"];
    	if ($url=="")
    	{
    		exit();
    	}
       	$format="U";
    }
    else
        {

    	$format="I";
    }
    return $format;
}

function insertWidget($id,$url,$format,$row,$module_validateexterneModule) {
    // insert new widget
    global $DB;
    $DB->execute($module_validateexterneModule,$id,$url,$row['title'],$row['desc'],$format,$row['heig'],$_SESSION['user_id'],date('Y-m-d'), date('Y-m-d'));
}

function insertCat($id) {
    global $DB;
    //insertion dans la categorie
    $DB->execute("INSERT INTO `dir_cat_item` (`item_id`, `category_id`, `first`) VALUES
    (".$id.", '2', 'Y')");
}

function getNumWidget() {
    global $DB;
    //recuperation  de la quantite de widget
    $DB->getResults("SELECT quantity FROM dir_category");
    $row=$DB->fetch(0);
    $quantity=$row['quantity'];
    return $quantity;
    }

function updateNumWidget($refreshcache_setQuantity,$quantity) {
    global $DB;
    //update du nombre de widget
    $DB->execute($refreshcache_setQuantity,$quantity,$_SESSION['user_id']);
}

function generationIcone($id) {
    // copie des icones
    @copy("../modules/pictures/_deficon72.gif", "../modules/pictures/box0_".$id.".ico");
}

function insertWidgetPortail($id,$rows,$module_updatemoduleexterne,$module_insertmoduleexterne){
    // INSERTION DU WIDGET DANS UNE PAGE DANS LE CAS OU IL EST NOUVEAU
    global $DB;
    //integration du widget dans le portail
    if ($rows['check']){
        $DB->getResults("SELECT item_id, posy, posj FROM module where user_id='".$_SESSION['user_id']."' and posx='1' and profile_id='".$rows['pagecourante']."'");
        while ($row=$DB->fetch(0)){
            $posy=$row['posy'];
            $posy++;
            $posj=$row['posj'];
            $posj++;
            $DB->execute($module_updatemoduleexterne,$posy,$posj,$row['item_id'],$_SESSION['user_id']);
        }
        $DB->execute($module_insertmoduleexterne,$id,$_SESSION['user_id'],$rows['pagecourante']);
    }
}

function write($str,$location,$encode=false){
	$handle='';
	$handle = @fopen ($location , "w" );
	if (!$handle) $this->warning(1);
	//LOCK the file to avoid multi input
	if ( !flock ( $handle , LOCK_EX + LOCK_NB )) $this->warning(2);
	//Write the HTML in this file
	if ($encode)
	{
		@fwrite ( $handle , utf8_encode($str));
	}
	else
	{
		@fwrite ( $handle , $str);
	}
	//@fwrite ( $this->handle , utf8_encode($str) , strlen ( $str ) ); // utf8 add cars and length is higher
	//Unlock the file & close
	@flock ( $handle , LOCK_UN );
	@fclose ( $handle );
}


function creationXmlParam($id,$row,$screxpertadd1_updateVars2) {
    global $DB;
    // Treat the options
    $i=0;
    $s='<?'.'xml version="1.0" encoding="UTF-8"'.'?><Module>';
    $defvar="";
    while (isset($row["varname".$i])){
    	$s.= '<UserPref name="'.$row["varname".$i].'" datatype="'.$row["vartype".$i].'" default_value="'. stripslashes($row["vardef".$i]).'" display_name="'.$row["vardname".$i].'" >';
	    $defvar.=$row["varname".$i].'='.$row["vardef".$i].'&';
    	$j=0;
	    while (isset($row["val".$i."_".$j])){
    		$s.='<EnumValue value="'.$row["val".$i."_".$j].'" display_value="'. stripslashes($row["vald".$i."_".$j]).'" />';
	    	$j++;
    	}
	    $s.= '</UserPref>';
        $i++;
    }
    $s.="</Module>";
    $DB->execute($screxpertadd1_updateVars2,$DB->quote($defvar),$i,$id);
    write($s,"../modules/module".$id."_param.xml");
}

function creationXmlContent($id,$row) {
    // Treat the content
    if ($row["type"]!="url"){
	    //generate module header
	    $s = '<'.'?php $id=$_GET["p"];?'.'>';
	    $s.= '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
	    $s.= '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">';
	    $s.= '<head>';
	    $s.= '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />';
	    $s.= '<link rel="stylesheet" type="text/css" media="screen" title="default" href="../styles/module.css" />';
	    $s.= '<script type="text/javascript" src="../includes/modules.js"></script>';
	    $s.= '<script type="text/javascript">var __MODULE_ID__=<'.'?php echo $id;?'.'></script>';
	    launch_hook('expertmodule_addInModuleHeader');
	    $s.= '</head>';
	    //generate module content
	    $s.= '<body onload="_IG_AdjustIFrameHeight();">';
	    $cont= formatWidgetCode($row["modcontent"]);
	    //only admin can add server scripts in the application
	    $cont = $_SESSION['type']=="A"?$cont:secureWidgetCode($cont);
	    // set module id value in widget code
	    $cont=str_replace("__MODULE_ID__","<"."?php echo $"."id;?".">",$cont);
	    $s.= $cont;
	    launch_hook('expertmodule_addInModuleFooter');
	    $s.= '</body></html>';
	    write($s,"../modules/module".$id.".php");
	    @chmod("../modules/module".$id.".php", 0755);
    }
}


function creationXmlCache($cache_getRootDirectoryChildren) {
    global $DB;
    $cache1 = '<?xml version="1.0" encoding="UTF-8"?><channel><path> Accueil du catalogue</path><parent>0</parent>';
    $ids = '0';
    $DB->getResults($cache_getRootDirectoryChildren,$DB->escape($ids));
    $number = $DB->nbResults();
    if ($number>0)
    {
	    while ($row = $DB->fetch(0))
	    {
		    $cache1.= "<dir>";
		    $cache1.= "<dirid>".$row['id']."</dirid>";
		    $cache1.= "<dirname><![CDATA[".$row['name']."]]></dirname>";
		    $cache1.= "<quantity>".$row['quantity']."</quantity>";
		    $cache1.= "<lang>".$row['lang']."</lang>";
		    $cache1.= "</dir>";
	    }
    }
    $DB->freeResults();
    $cache1.='</channel>';
    write($cache1,"../cache/cat_0.xml");
}

function creationXmlCache2($cache_getDirectoryInformation,$module_getModuleInformationXml) {
    global $DB;
    //2eme fichier cache
    $ide='2';
    $cache2='<?xml version="1.0" encoding="UTF-8"?><channel>';
    if ($ide>0){
    	$curcat = $ide;
	    $curcattext = "";
    	$curcatname = "";
	    while ($curcat>0){
    		$DB->getResults($cache_getDirectoryInformation,$DB->escape($curcat));
	    	$row = $DB->fetch(0);
		    if ($curcat==$ide){
    			$curcatname = $row["name"];
	    		$curquantity=$row["quantity"];
		    	$curcattext = "> " . $curcatname;
			    $cache2.= "<parent>".$row["parent_id"]."</parent>";
    		}else{
    			$curcattext = "> <a href=# onclick='p_addContent.getDir(".$row["id"].")' style='color:#000000;text-decoration:underline;'>" . $row["name"] . "</a> " . $curcattext;
	    	}
		    $curcat = $row["parent_id"];
    		$DB->freeResults();
	    }
    	$cache2.= "<dirname><![CDATA[".$curcatname." (".$curquantity.")]]></dirname>";
	    $cache2.= "<path><![CDATA[ <A href=# onclick='p_addContent.getDir(0)' style='color:#000000;text-decoration:underline;'>Accueil</A> " . $curcattext . " ]]></path>";
    }
    $DB->getResults($module_getModuleInformationXml,$DB->escape($ide));
    if ($DB->nbResults()>0){
    	while ($row = $DB->fetch(0)){
    		$cache2.= "<item>";
	    	$cache2.= "<id>".$row['id']."</id>";
		    $cache2.= "<name><![CDATA[".$row['name']."]]></name>";
    		$cache2.= "<rank>".$row['nota']."</rank>";
    		$cache2.= "</item>";
	    }
    }
    $DB->freeResults();
    $cache2.='</channel>';
	write($cache2,"../cache/cat_2_fr.xml");
}

function xmlItemCache($id) {
    global $DB;
    //creation xml cache
    $DB->getResults("SELECT * FROM dir_item,users WHERE dir_item.editor_id=users.id and dir_item.id=".$id);
    $row = $DB->fetch(0);
    $ss = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><item><id>".$id."</id>
    <name><![CDATA[".$row['name']."]]></name>
    <url><![CDATA[".$row['url']."]]></url>
    <size>".$row['height']."</size>
    <minwidth>".$row['minwidth']."</minwidth>
    <sizable>".$row['sizable']."</sizable>
    <format>".$row['format']."</format>
    <var><![CDATA[".$row['defvar']."]]></var>
    <nota>".$row['notation']."</nota>
    <description><![CDATA[".$row['description']."]]></description>
    <website><![CDATA[".$row['website']."]]></website>
    <nbvars>".$row['nbvariables']."</nbvars>
    <usereader>".$row['usereader']."</usereader>
    <autorefresh>".$row['autorefresh']."</autorefresh>
    <editor_id>".$row['editor_id']."</editor_id>
    <editor><![CDATA[".$row['long_name']."]]></editor>
    <creation_date>".$row['creation_date']."</creation_date></item>";
    write($ss,"../cache/item_".$id.".xml");
}

function redir($pagecourante) {
    echo '<script language="Javascript">
    document.location.replace("'.$pagecourante.'");
    </script>';
}
?>
